{.pl 84}
{.lw 110}
{ͻ
                                                                           
                V 2 4   -   D R I V E R   -   T E S T                      
                                                                           
 ͹
      Copyright (C) 1993 by Vision Systems GmbH, Norderstedt, Germany      
                           All rights reserved                             
 ͹
                                                                           
  Dieses Programm zeigt die Ansteuerung der COM-Ports ber die V24DRV-     
  Unit. Es ist ein einfaches Terminal-Programm, das die Tastatur-Eingaben  
  auf bis zu 4 COM-Ports schreibt und den Input der COM-Ports verschieden- 
  farbig auf den Bildschirm bringt. Die COM-Ports knnen in beliebiger     
  Konfiguration ohne, mit verschiedenen oder mit gesharten Interrupts      
  betrieben werden.                                                        
                                                                           
                                                                           
 ͹
  19.Oct.93 WW: 1st release                                                
  19.Nov.93 WW: Interrupt Sharing                                          
 ͼ}
{$M 8192,$1000,$8000}
{$A+,B-,F-,I-,O-,R-,S-,X+}
Program TestV24;


Uses V24Drv,
     Crt;


Const
  { verwendete Adressen und Interrupts. Adr=0 schaltet Port aus,
                                        Irq=0 schaltet Irq aus }
  Com1Adr  = $3e0;
  Com1Irq  = 10;
  Com1Baud = 115200;
  Com1Col  = Blue;

  Com2Adr  = $2E0;
  Com2Irq  = 11;
  Com2Baud = 115200;
  Com2Col  = Green;

  Com3Adr  = $3F8;
  Com3Irq  = 4;
  Com3Baud = 19200;
  Com3Col  = Yellow;

  Com4Adr  = $3E8;
  Com4Irq  = 10;
  Com4Baud = 75;
  Com4Col  = Red;



{.cp 20}
{Ŀ
;   H a u p t    S c h l e i f e                                       
;}
Procedure Main;
  Var IBuf,Obuf:String;
  Var Ch:Char;i,Ret:Integer; ta:Byte;
  Begin
    ta := TextAttr; { alte Farben retten }
    For i:=1 to 16 do Writeln;
      Repeat
        { Test auf Tastatur-Eingabe: }
        OBuf:='';
        While KeyPressed do
          begin
            Ch := ReadKey;
            If Ch=#3 then Exit;
            If Ch=#0 then Ch:=ReadKey else
            If Ch=#27 then OBuf:=OBuf+#13#10'ABCDEFGHIJKLMNOPQRSTUVWXYZ'#13#10 else
            OBuf:=OBuf+Ch;
          end;
        If OBuf<>'' then For i := 1 to 4 do
          begin
            Ret:=SendBuffer(i,OBuf[1],Length(OBuf));
          end;
        { Input von den COM Ports: }
        for i := 1 to 4 do
          Begin
            Ret:=RecvBuffer(i,IBuf[1],255);
            If Ret>0 then
              begin
                IBuf[0]:=Chr(Ret);
                ta := TextAttr;
                  Case i of
                    1: TextColor(Com1Col);
                    2: TextColor(Com2Col);
                    3: TextColor(Com3Col);
                    4: TextColor(Com4Col);
                  End;
                Write(IBuf);
                TextAttr:=ta;
              end;
          End;
      Until False;
  End;


{.cp 20}
{Ŀ
;                  I n i t i a l i s i e r u n g                       
;}
Procedure ComInit(Num:Byte);
  Var UART:Byte; Ret:Boolean;
  Begin
    { Initialisierung der Ports: }
      Case Num of
        1: If Com1Adr<>0 then Ret:=Init_V24(1,Com1Adr,Com1Irq,9256,9256) else Exit;
        2: If Com2Adr<>0 then Ret:=Init_V24(2,Com2Adr,Com2Irq,256,256) else Exit;
        3: If Com3Adr<>0 then Ret:=Init_V24(3,Com3Adr,Com3Irq,256,256) else Exit;
        4: If Com4Adr<>0 then Ret:=Init_V24(4,Com4Adr,Com4Irq,256,256) else Exit;
        else Exit;
      End;
    If not Ret then
      begin
        Writeln('ERROR: Com',Num,' Init failed!');
        Exit;
      end;
    Uart := Uart_Class(Num);
    Write('Com',Num,' Uart-Class:');
    If (Uart and uaScratch)<>0 then Write(' ScratchReg.');
    If (Uart and uaAFR)<>0 then Write(' AFR');
    If (Uart and uaFifo)<>0 then Write(' FIFO');
    If (Uart and uaLoop)<>0 then Write(' LoopBack');
    Writeln;
    { Baudraten setzen }
      Case Num of
        1: Set_Baudrate(1,Com1Baud);
        2: Set_Baudrate(2,Com2Baud);
        3: Set_Baudrate(3,Com3Baud);
        4: Set_Baudrate(4,Com4Baud);
      End;

    Set_LineParam(Num,lp8Bits); { Line-Parameter setzen: }
    {Set_Handshake(Num,hsInXOn or hsInRTS or hsOutXOn or hsOutCTS);}
    Set_MCR(Num,mpDTR or mpRTS); { Modem-Parameter setzen: }

    { ggf. Handshake Management setzen: }
    {Set_Handshake(Num,hsInXOn or hsInRTS or hsOutXOn or hsOutCTS);}
  End;


{.cp 20}
{Ŀ
;                 M A I N  -  P R O G R A M                            
;}
BEGIN
  Writeln;
  { Initialisierung: }
  If not Set_IntVect($64) then
    Begin
      Writeln('V24DRV TSR kann nicht angesprochen werden');
      Halt(1);
    End;

  ComInit(1);
  ComInit(2);
  ComInit(3);
  ComInit(4);

  Main; { Hauptprogramm }
  Writeln;

  { Abschalten der Com-Ports }
  Exit_V24(4);
  Exit_V24(3);
  Exit_V24(2);
  Exit_V24(1);
  Writeln;
END.