{.pl 84}
{.lw 110}
{ͻ
                                                                           
                       V 2 4   -   D R I V E R                             
                                                                           
 ͹
      Copyright (C) 1993 by Vision Systems GmbH, Norderstedt, Germany      
                           All rights reserved                             
 ͹
  Treiber-Routinen zur Ansteuerung von COM-Schnittstellen. Es werden max.  
  8 Com-Ports bedient, wobei Interrupt-Sharing und FIFOs untersttzt       
  werden. Die Routinen arbeiten - mit einigen Einschrnkungen - auch im    
  Polling-Mode. Als Handshake-Mglichkeiten (nur im Interrupt-Modus)       
  stehen zur Verfgung:                                                    
    Output: CTS und/oder XOn/XOff                                          
    Input : RTS und/oder XOn/XOff                                          
  Um die Verknpfung von Code und Daten bersichtlich zu gestalten, wurde  
  eine Object-orientierte Schreibweise gewhlt. Um jedoch das Benutzer-    
  Interface so allgemein wie mglich zu gestalten und die Kapselung als    
  DLL zu ermglichen, gibt es eine Schicht von Nicht-Object-orientierten   
  Einsprngen. Die Interrupt-Routinen wurden in Assembler Inline           
  geschrieben; es gibt keine Call-Backs zum Pascal-Teil. Da ein Rechner    
  der AT-Klasse mit '286 oder hher vorausgesetzt wird, werden '286er      
  Befehle benutzt und das Vorhandensein von 2 kaskadierten Interrupt-      
  Controllern vorausgesetzt.                                               
  Das Modul V24DRV.INC ist selbst nicht kompilier-fhig sondern mu von    
  einem Pascal-Programm, einer Pascal-Unit oder einer Protected-Mode       
  Library included werden. Dabei sind folgende Compiler Defines zu         
  setzen:                                                                  
    DLL    : zur Erzeugung einer Protected Mode DLL                        
    USEDLL : zur Erzeugung einer Interface Unit, die die DLL aufruft       
    TSR    : zur Erzeugung eines TSRs                                      
    USETSR : zur Erzeugung einer Interface Unit, die das TSR aufruft       
                                                                           
 ͹
  19.Oct.93 WW: 1st release. Author: Winfried Wolf                         
  19.Nov.93 WW: Interrupt Sharing                                          
  24.Mar.94 WK: Auslagerung der DIRECT-Routinen nach V24DRV.SRC            
 ͼ}

{$IFDEF USEDLL}
  {$DEFINE ISUNIT}
  {$UNDEF DIRECT}
{$ELSE}
  {$IFDEF USETSR}
    {$DEFINE ISUNIT}
    {$UNDEF DIRECT}
    {$DEFINE TSRDEFS}
  {$ELSE}
    {$IFDEF DLL}
      {$UNDEF ISUNIT}
      {$DEFINE DIRECT}
    {$ELSE}
      {$IFDEF TSR}
        {$UNDEF ISUNIT}
        {$DEFINE DIRECT}
        {$DEFINE TSRDEFS}
      {$ELSE}
        {$DEFINE ISUNIT}
        {$DEFINE DIRECT}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}


{$B-,F-,I-,R-,S-}
{$IFDEF DLL}
{$C FIXED PRELOAD PERMANENT}
{$ENDIF}




{$IFDEF ISUNIT}
Interface
{$ENDIF}

{$IFDEF TSRDEFS}
TYPE
  InitParam = Record
    PortAddr : Word;
    Int      : Word;
    IBSize   : Integer;
    OBSize   : Integer;
  End;

CONST
  _Init_V24        = $01;
  _Exit_V24        = $02;
  _IntLog          = $03;
  _Set_BaudRate    = $04;
  _Set_BaudDivisor = $05;
  _SendBuffer      = $06;
  _RecvBuffer      = $07;
  _Set_LineParam   = $08;
  _ClearInpBuffer  = $09;
  _ClearOutBuffer  = $0A;
  _Get_InpUsed     = $0B;
  _Get_OutFree     = $0C;
  _Get_MSR         = $0D;
  _Get_LSR         = $0E;
  _Get_MCR         = $0F;
  _Set_Handshake   = $10;
  _Set_MCR         = $11;
  _Uart_Class      = $12;
  _All_Sent        = $13;
{$ENDIF}


Const
  { line control register parameter: }
  lp5Bits    = $00;
  lp6Bits    = $01;
  lp7Bits    = $02;
  lp8Bits    = $03;
  lp1Stop    = $00;
  lp2Stop    = $04;
  lpNone     = $00;
  lpEven     = $18;
  lpOdd      = $08;

  { modem control register parameter: }
  mpDTR      = $01;
  mpRTS      = $02;

  { interrupt driver status: }
  isMSCint   = $01;
  isTXEint   = $02;
  isRXRint   = $04;
  isLSCint   = $08;
  isInpOvr   = $10;

  { handshake parameter: }
  hsInDTR    = $01;
  hsInRTS    = $02;
  hsInXOn    = $04;
  hsOutCTS   = $10;
  hsOutDSR   = $20;
  hsOutXOn   = $40;

  { modem control parameter: }
  mcDTROn    = $01;
  mcDTROff   = $02;
  mcRTSOn    = $04;
  mcRTSOff   = $08;

  { UART classification and test flags }
  uaScratch = $01;
  uaFifo    = $02;
  uaLoop    = $04;
  uaAFR     = $08;
  uaCompat  = $10;



{$IFDEF ISUNIT}
{.cp 20}
{Ŀ
; UNIT Interface procedure list                                        
;}
{$IFDEF UseTSR}
FUNCTION Set_IntVect(Int:Byte):Boolean;
{$ENDIF}
FUNCTION  Init_V24(ComNum:Byte;aPortAddr:Word;anInt:Byte;IBSiz,OBSiz:Integer):Boolean;
PROCEDURE Exit_V24(ComNum:Byte);
FUNCTION  IntLog(ComNum:Byte):Byte;
PROCEDURE Set_BaudRate(ComNum:Byte;BR:LongInt);
PROCEDURE Set_BaudDivisor(ComNum:Byte;BD:Word);
FUNCTION  SendBuffer(ComNum:Byte;Var Buf;Cnt:Integer):Integer;
FUNCTION  RecvBuffer(ComNum:Byte;Var Buf;Cnt:Integer):Integer;
PROCEDURE Set_LineParam(ComNum:Byte;LP:Byte);
PROCEDURE ClearInpBuffer(ComNum:Byte);
PROCEDURE ClearOutBuffer(ComNum:Byte);
FUNCTION  Get_InpUsed(ComNum:Byte):Integer;
FUNCTION  Get_OutFree(ComNum:Byte):Integer;
FUNCTION  Get_MSR(ComNum:Byte):Byte;
FUNCTION  Get_LSR(ComNum:Byte):Byte;
FUNCTION  Get_MCR(ComNum:Byte):Byte;
PROCEDURE Set_Handshake(ComNum:Byte;HS:Byte);
PROCEDURE Set_MCR(ComNum:Byte;Lines:Byte);
FUNCTION  Uart_Class(ComNum:Byte):Byte;
FUNCTION  All_Sent(ComNum:Byte):Boolean;

Implementation
{$IFDEF UseTSR}
Uses Dos;
{$ENDIF}

{$ENDIF}

{$IFDEF UseDLL}
{.cp 20}
{Ŀ
; Interface part to DLL                                                
;}
FUNCTION  Init_V24(ComNum:Byte;aPortAddr:Word;anInt:Byte;IBSiz,OBSiz:Integer):Boolean; External 'V24DLL';
PROCEDURE Exit_V24(ComNum:Byte); External 'V24DLL';
FUNCTION  IntLog(ComNum:Byte):Byte; External 'V24DLL';
PROCEDURE Set_BaudRate(ComNum:Byte;BR:LongInt); External 'V24DLL';
PROCEDURE Set_BaudDivisor(ComNum:Byte;BD:Word); External 'V24DLL';
FUNCTION  SendBuffer(ComNum:Byte;Var Buf;Cnt:Integer):Integer; External 'V24DLL';
FUNCTION  RecvBuffer(ComNum:Byte;Var Buf;Cnt:Integer):Integer; External 'V24DLL';
PROCEDURE Set_LineParam(ComNum:Byte;LP:Byte); External 'V24DLL';
PROCEDURE ClearInpBuffer(ComNum:Byte); External 'V24DLL';
PROCEDURE ClearOutBuffer(ComNum:Byte); External 'V24DLL';
FUNCTION  Get_InpUsed(ComNum:Byte):Integer; External 'V24DLL';
FUNCTION  Get_OutFree(ComNum:Byte):Integer; External 'V24DLL';
FUNCTION  Get_MSR(ComNum:Byte):Byte; External 'V24DLL';
FUNCTION  Get_LSR(ComNum:Byte):Byte; External 'V24DLL';
FUNCTION  Get_MCR(ComNum:Byte):Byte; External 'V24DLL';
PROCEDURE Set_Handshake(ComNum:Byte;HS:Byte); External 'V24DLL';
PROCEDURE Set_MCR(ComNum:Byte;Lines:Byte); External 'V24DLL';
FUNCTION  Uart_Class(ComNum:Byte):Byte; External 'V24DLL';
FUNCTION  All_Sent(ComNum:Byte):Boolean; External 'V24DLL';
{$ENDIF}

{$IFDEF DIRECT}
Const
  MaxCom = 8; { COM1 .. COM8 }

{$I V24DRV.SRC  wird nur mit Vollversion geliefert }

{$ENDIF}

{$IFDEF DLL}
{.cp 20}
{Ŀ
; DLL export list                                                      
;}
Exports Init_V24;
Exports Exit_V24;
Exports IntLog;
Exports Set_BaudRate;
Exports Set_BaudDivisor;
Exports SendBuffer;
Exports RecvBuffer;
Exports Set_LineParam;
Exports ClearInpBuffer;
Exports ClearOutBuffer;
Exports Get_InpUsed;
Exports Get_OutFree;
Exports Get_MSR;
Exports Get_LSR;
Exports Get_MCR;
Exports Set_Handshake;
Exports Set_MCR;
Exports Uart_Class;
Exports All_Sent;
{$ENDIF}

