{.lw 110}
{.pl 84}
Unit V24Drv;

{$A+,G+,O-,X+}

{$IFDEF DPMI}
{$DEFINE UseDLL}
{$ELSE}
{$DEFINE USETSR}
{$ENDIF}


{$I V24Drv.Inc}

{$IFDEF UseTSR}
{.cp 20}
{Ŀ
; Interrupt Einsprungspunkt                                            
;}
Procedure IntEntry; near; Assembler;
  Asm
    db      0EBh
    db      8
    db      'V24DRV'
    dw      0
    mov     ax,-2
  End;


Const IntPnt : Pointer = @IntEntry;

{.cp 20}
{Ŀ
; Interrupt Call                                                       
;}
Function CallDrv(rAX:Word;rCXDX:LongInt;rESDI:Pointer):Word; Assembler;
  Asm
    sti
    mov     ax,[rAX]
    mov     dx,word ptr [rCXDX]
    mov     cx,word ptr [rCXDX+2]
    les     di,[rESDI]
    push    bp
    push    ds
    pushf
    call    [IntPnt]
    pop     ds
    pop     bp
  End;

{.cp 20}
{Ŀ
; Check Interrupt Vector;                                              
; 00: unused;  01: used by other software;  02: used by V24TSR         
;}
Function CheckVect(Vect:Pointer):Byte;
  var i:Integer;
  Begin
    If (Vect<>Nil) and (Seg(Vect^)<>$F000) then
      Begin
        CheckVect:=1;
        If (Seg(Vect^)>$F000) or (Ofs(Vect^)>$FF00)  then Exit;
        for i:=0 to 7 do If Mem[Seg(Vect^):Ofs(Vect^)+i]
                         <> Mem[Seg(IntEntry):Ofs(IntEntry)+i] then Exit;
        CheckVect:=2;
      End Else CheckVect:=0;
  End;

Procedure Init_V24Drv;
  Begin
  End;

FUNCTION Set_IntVect(Int:Byte):Boolean;
  Var Vect:Pointer;
  Begin
    Set_IntVect:=False;
    If (Int<$60) then Exit;
    GetIntVec(Int,Vect);
    If CheckVect(Vect)<>2 then Exit;
    IntPnt:=Vect;
    Set_IntVect:=True;
  End;

FUNCTION  Init_V24(ComNum:Byte;aPortAddr:Word;anInt:Byte;IBSiz,OBSiz:Integer):Boolean;
  var par:InitParam;
  Begin
    With par do
      begin
        PortAddr := aPortAddr;
        Int      := anInt;
        IBSize   := IBSiz;
        OBSize   := OBSiz;
      end;
    Init_V24:=CallDrv((_Init_V24 SHL 8)+ComNum,0,@par)=1;
  End;

PROCEDURE Exit_V24(ComNum:Byte);
  Begin
    CallDrv((_Exit_V24 SHL 8)+ComNum,0,Nil);
  End;

FUNCTION  IntLog(ComNum:Byte):Byte;
  Begin
    IntLog := CallDrv((_IntLog SHL 8)+ComNum,0,Nil);
  End;

PROCEDURE Set_BaudRate(ComNum:Byte;BR:LongInt);
  Begin
    CallDrv((_Set_Baudrate SHL 8)+ComNum,BR,Nil);
  End;

PROCEDURE Set_BaudDivisor(ComNum:Byte;BD:Word);
  Begin
    CallDrv((_Set_BaudDivisor SHL 8)+ComNum,BD,Nil);
  End;

FUNCTION  SendBuffer(ComNum:Byte;Var Buf;Cnt:Integer):Integer;
  Begin
    SendBuffer := CallDrv((_SendBuffer SHL 8)+ComNum,Cnt,@Buf);
  End;

FUNCTION  RecvBuffer(ComNum:Byte;Var Buf;Cnt:Integer):Integer;
  Begin
    RecvBuffer := CallDrv((_RecvBuffer SHL 8)+ComNum,Cnt,@Buf);
  End;

PROCEDURE Set_LineParam(ComNum:Byte;LP:Byte);
  Begin
    CallDrv((_Set_LineParam SHL 8)+ComNum,LP,Nil);
  End;

PROCEDURE ClearInpBuffer(ComNum:Byte);
  Begin
    CallDrv((_ClearInpBuffer SHL 8)+ComNum,0,Nil);
  End;

PROCEDURE ClearOutBuffer(ComNum:Byte);
  Begin
    CallDrv((_ClearOutBuffer SHL 8)+ComNum,0,Nil);
  End;

FUNCTION  Get_InpUsed(ComNum:Byte):Integer;
  Begin
    Get_InpUsed := CallDrv((_Get_InpUsed SHL 8)+ComNum,0,Nil);
  End;

FUNCTION  Get_OutFree(ComNum:Byte):Integer;
  Begin
    Get_OutFree := CallDrv((_Get_OutFree SHL 8)+ComNum,0,Nil);
  End;

FUNCTION  Get_MSR(ComNum:Byte):Byte;
  Begin
    Get_MSR := CallDrv((_Get_MSR SHL 8)+ComNum,0,Nil);
  End;

FUNCTION  Get_LSR(ComNum:Byte):Byte;
  Begin
    Get_LSR := CallDrv((_Get_LSR SHL 8)+ComNum,0,Nil);
  End;

FUNCTION  Get_MCR(ComNum:Byte):Byte;
  Begin
    Get_MCR := CallDrv((_Get_MCR SHL 8)+ComNum,0,Nil);
  End;

PROCEDURE Set_Handshake(ComNum:Byte;HS:Byte);
  Begin
    CallDrv((_Set_Handshake SHL 8)+ComNum,HS,Nil);
  End;

PROCEDURE Set_MCR(ComNum:Byte;Lines:Byte);
  Begin
    CallDrv((_Set_MCR SHL 8)+ComNum,Lines,Nil);
  End;

FUNCTION  Uart_Class(ComNum:Byte):Byte;
  Begin
    Uart_Class := CallDrv((_Uart_Class SHL 8)+ComNum,0,Nil);
  End;

FUNCTION  All_Sent(ComNum:Byte):Boolean;
  Begin
    All_Sent := CallDrv((_All_Sent SHL 8)+ComNum,0,Nil)=1;
  End;


{$ENDIF}

{$IFNDEF UseDLL}
BEGIN
  Init_V24Drv;
{$ENDIF}
END.
