{.pl 84}
{.lw 110}
{ͻ
                                                                           
                V 2 4   -   D R I V E R   -  T S R                         
                                                                           
 ͹
      Copyright (C) 1993 by Vision Systems GmbH, Norderstedt, Germany      
                           All rights reserved                             
 ͹
                                                                           
 ͹
  09.Dec.93 WW: 1st release. Author: Winfried Wolf                         
 ͼ}
{$M 4096,800,800}
{$A+,G+,O-,X+}
Program V24TSR;
{$IFDEF DPMI}   !! ACHTUNG: Real-Mode whlen !!         {$ENDIF}

Uses Dos;

{$DEFINE TSR}


{$I V24DRV.INC}


CONST
  Version = $0001;

VAR
  i,j    : integer;
  Line   : String;
  Int    : Integer;
  OldVec : Pointer;


{.cp 20}
{Ŀ
; Aufruf-Verteiler                                                     
;}
Function Dispatch(Func:Word;Par:LongInt;Pnt:Pointer):Word; Near;
  Begin
    Dispatch:=0;
      Case Hi(Func) of
        $00: Dispatch := Version;
        _Init_V24        :
          If (Pnt<>Nil) and Init_V24(Lo(Func), InitParam(Pnt^).PortAddr,
                                               InitParam(Pnt^).Int,
                                               InitParam(Pnt^).IBSize,
                                               InitParam(Pnt^).OBSize)
          then Dispatch:=1 else Dispatch:=0;
        _Exit_V24        : Exit_V24(Lo(Func));
        _IntLog          : Dispatch := IntLog(Lo(Func));
        _Set_BaudRate    : Set_Baudrate(Lo(Func),Par);
        _Set_BaudDivisor : Set_BaudDivisor(Lo(Func),Par);
        _SendBuffer      : Dispatch := SendBuffer(Lo(Func),Pnt^,Par);
        _RecvBuffer      : Dispatch := RecvBuffer(Lo(Func),Pnt^,Par);
        _Set_LineParam   : Set_LineParam(Lo(Func),Par);
        _ClearInpBuffer  : ClearInpBuffer(Lo(Func));
        _ClearOutBuffer  : ClearOutBuffer(Lo(Func));
        _Get_InpUsed     : Dispatch := Get_InpUsed(Lo(Func));
        _Get_OutFree     : Dispatch := Get_OutFree(Lo(Func));
        _Get_MSR         : Dispatch := Get_MSR(Lo(Func));
        _Get_LSR         : Dispatch := Get_LSR(Lo(Func));
        _Get_MCR         : Dispatch := Get_MCR(Lo(Func));
        _Set_Handshake   : Set_Handshake(Lo(Func),Par);
        _Set_MCR         : Set_MCR(Lo(Func),Par);
        _Uart_Class      : Dispatch := Uart_Class(Lo(Func));
        _All_Sent        : If All_Sent(Lo(Func)) then Dispatch:=1;
        $FF: Begin
               Exit_V24Drv;
               SetIntVec(Int,OldVec);
               (*
                 Asm
                   mov     es,[PrefixSeg]
                   mov     es,es:[2Ch]
                   mov     ah,49h
                   int     21h
                   mov     es,[PrefixSeg]
                   mov     ah,49h
                   int     21h
                 End;
               *)
               Dispatch := PrefixSeg;
             End;
        Else Dispatch := $FF;
      End;
  End;


{.cp 20}
{Ŀ
; Interrupt Einsprungspunkt                                            
;}
Procedure IntEntry; near; Assembler;
  Asm
    db      0EBh
    db      8
    db      'V24DRV'
    dw      Version
    push    ds
    push    bp
    mov     bp,sp
    push    ax
    push    cx
    push    dx
    push    es
    push    di
    mov     ax,Seg @Data
    mov     ds,ax
    call    Dispatch
    pop     bp
    pop     ds
    iret
  End;


{.cp 20}
{Ŀ
; Interrupt Call                                                       
;}
Function CallDrv(Func:Word):Word; Assembler;
  Asm
    sti
    mov     ax,[Func]
    push    bp
    push    ds
    pushf
    call    [OldVec]
    pop     ds
    pop     bp
  End;

{.cp 20}
{Ŀ
; Check Interrupt Vector;                                              
; 00: unused;  01: used by other software;  02: used by V24TSR         
;}
Function CheckVect:Byte;
  var i:Integer;
  Begin
    If (OldVec<>Nil) and (Seg(OldVec^)<>$F000) then
      Begin
        CheckVect:=1;
        If (Seg(OldVec^)>$F000) or (Ofs(OldVec^)>$FF00)  then Exit;
        for i:=0 to 7 do If Mem[Seg(OldVec^):Ofs(OldVec^)+i]
                         <> Mem[Seg(IntEntry):Ofs(IntEntry)+i] then Exit;
        CheckVect:=2;
      End Else CheckVect:=0;
  End;

Procedure ExitOld;
  var oldSeg:Word;
  Begin
    OldSeg := CallDrv($FF00);
    If (OldSeg>0) and (OldSeg<$F000) then
      Begin
          Asm
            mov     es,[OldSeg]
            mov     es,es:[2Ch]
            mov     ah,49h
            int     21h
            mov     es,[OldSeg]
            mov     ah,49h
            int     21h
          End;
        Writeln('alter Treiber entfernt');
      End else Writeln('alter Treiber kann nicht entfernt werden. (Code=',OldSeg,')');
  End;


BEGIN
  Writeln('Vision Systems V24 TSR');
  If ParamCount=0 then
    begin
      writeln('FEHLER: Software-Interrupt-Parameter fehlt!');
      Halt(1);
    end;
  Line := ParamStr(1);
  Val(Line,Int,i);
  If (i<>0) or (Int<$60) or (Int>$FF) or (Int=$67) or (Int=$6D) or
     ((Int>=$70) and (Int<=$77)) then
    begin
      writeln('FEHLER: kein gltiger Software-Interrupt-Parameter!');
      Halt(1);
    end;
  GetIntVec(Int,OldVec);
  If ParamCount>1 then
    begin
      Line:=ParamStr(2);
      for i:=1 to Length(Line) do Line[i]:=UpCase(Line[i]);
      If Line='UNLOAD' then
        Begin
          If (CheckVect=2) then
            begin
              ExitOld;
            end else Writeln('bei diesem Interrupt ist kein Treiber geladen');
          Halt;
        End else
        Begin
          Writeln('Fehler: Parameter 2 unbekannt');
          Halt(1);
        End;
    end;

    Case CheckVect of
      1: Begin
           Writeln('FEHLER: Interrupt Vektor ist nicht frei !');
           Halt(1);
         End;
      2: Begin
           Writeln('ACHTUNG: Treiber ist bereits geladen.');
           Halt;
         End;
    End; { Case }
  SetIntVec(Int,@IntEntry);
  Writeln('V24 TSR geladen ! Aufruf ber Int ',Int);
  {restore vectors captured by runtime library}
  SetIntVec($00, SaveInt00);
  SetIntVec($02, SaveInt02);
  SetIntVec($1B, SaveInt1B);
  SetIntVec($23, SaveInt23);
  SetIntVec($24, SaveInt24);
  SetIntVec($34, SaveInt34);
  SetIntVec($35, SaveInt35);
  SetIntVec($36, SaveInt36);
  SetIntVec($37, SaveInt37);
  SetIntVec($38, SaveInt38);
  SetIntVec($39, SaveInt39);
  SetIntVec($3A, SaveInt3A);
  SetIntVec($3B, SaveInt3B);
  SetIntVec($3C, SaveInt3C);
  SetIntVec($3D, SaveInt3D);
  SetIntVec($3E, SaveInt3E);
  SetIntVec($3F, SaveInt3F);
  SetIntVec($75, SaveInt75);
  Keep(0);
END.

